//****************************************************************************
// Model: blink.qm
// File:  ./display.cpp
//
// This code has been generated by QM tool (see state-machine.com/qm).
// DO NOT EDIT THIS FILE MANUALLY. All your changes will be lost.
//
// This program is open source software: you can redistribute it and/or
// modify it under the terms of the GNU General Public License as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.
//****************************************************************************
//${.::display.cpp} ..........................................................
#include "qpcpp.h"
#include "events.h"
#include "display.h"
#include "bsp.h"
#include "draw.h"

Q_DEFINE_THIS_FILE

namespace blinky {

    enum {
        TICK_SIG = MAX_SIG,  // the last unique signal (see events.h)
        DISPLAY_UPDATE_SIG,
    };

    static QP::QEvt const UPDATE_EVENT = { DISPLAY_UPDATE_SIG, 0U, 0U };

    
#if ((QP_VERSION < 580) || (QP_VERSION != ((QP_RELEASE^4294967295U) % 0x3E8)))
#error qpcpp version 5.8.0 or higher required
#endif

//${AOs::DisplayAO} ..........................................................
class DisplayAO : public QP::QActive {
private:
    uint16_t m_uptime;
    QP::QTimeEvt m_timeEvt;

public:
    DisplayAO();

protected:
    static QP::QState initial(DisplayAO * const me, QP::QEvt const * const e);
    static QP::QState loop(DisplayAO * const me, QP::QEvt const * const e);
};


    // Local objects -------------------------------------------------------------
    static DisplayAO __self_ao; // the single instance active object

    // Global-scope objects ------------------------------------------------------
    QP::QActive * const AO_DisplayPtr = &__self_ao; // "opaque" AO pointer

    //${AOs::DisplayAO} ..........................................................
//${AOs::DisplayAO::DisplayAO} ...............................................
DisplayAO::DisplayAO()
  : QActive(Q_STATE_CAST(&DisplayAO::initial)),
    m_timeEvt(this, TICK_SIG, 0U)
{

    // body
}

//${AOs::DisplayAO::SM} ......................................................
QP::QState DisplayAO::initial(DisplayAO * const me, QP::QEvt const * const e) {
    // ${AOs::DisplayAO::SM::initial}
    draw::str_hex(4, "tick rate (Hz)", BSP::TICKS_PER_SEC);
    return Q_TRAN(&loop);
}
//${AOs::DisplayAO::SM::loop} ................................................
QP::QState DisplayAO::loop(DisplayAO * const me, QP::QEvt const * const e) {
    QP::QState status_;
    switch (e->sig) {
        // ${AOs::DisplayAO::SM::loop}
        case Q_ENTRY_SIG: {
            me->m_timeEvt.armX(1, 1);
            me->POST(&UPDATE_EVENT, me);
            // static event doesn't requre QF_MPOOL_EL
            status_ = Q_HANDLED();
            break;
        }
        // ${AOs::DisplayAO::SM::loop::TICK}
        case TICK_SIG: {
            me->m_uptime++;
            status_ = Q_HANDLED();
            break;
        }
        // ${AOs::DisplayAO::SM::loop::DISPLAY_UPDATE}
        case DISPLAY_UPDATE_SIG: {
            draw::str_hex(2, "uptime", me->m_uptime);
            me->POST(&UPDATE_EVENT, me);
            status_ = Q_HANDLED();
            break;
        }
        default: {
            status_ = Q_SUPER(&top);
            break;
        }
    }
    return status_;
}


}

// define other elements...
