//****************************************************************************
// Model: blink.qm
// File:  ./left.cpp
//
// This code has been generated by QM tool (see state-machine.com/qm).
// DO NOT EDIT THIS FILE MANUALLY. All your changes will be lost.
//
// This program is open source software: you can redistribute it and/or
// modify it under the terms of the GNU General Public License as published
// by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.
//****************************************************************************
//${.::left.cpp} .............................................................
#include "qpcpp.h"
#include "events.h"
#include "left.h"
#include "bsp.h"

Q_DEFINE_THIS_FILE

namespace blinky {

    enum {
        TIMEOUT_SIG = MAX_SIG,  // the last unique signal (see events.h)
    };

    
#if ((QP_VERSION < 580) || (QP_VERSION != ((QP_RELEASE^4294967295U) % 0x3E8)))
#error qpcpp version 5.8.0 or higher required
#endif

//${AOs::LeftAO} .............................................................
class LeftAO : public QP::QActive {
private:
    QP::QTimeEvt m_timeEvt;

public:
    LeftAO();

protected:
    static QP::QState initial(LeftAO * const me, QP::QEvt const * const e);
    static QP::QState Left(LeftAO * const me, QP::QEvt const * const e);
    static QP::QState Blinky(LeftAO * const me, QP::QEvt const * const e);
    static QP::QState history(LeftAO * const me, QP::QEvt const * const e);
    static QP::QState red_on(LeftAO * const me, QP::QEvt const * const e);
    static QP::QState green_on(LeftAO * const me, QP::QEvt const * const e);
    static QP::QState blue_on(LeftAO * const me, QP::QEvt const * const e);
    static QP::QState off(LeftAO * const me, QP::QEvt const * const e);

protected:
    QP::QStateHandler his_history;
};


    // Local objects -------------------------------------------------------------
    static LeftAO __self_ao; // the single instance active object

    // Global-scope objects ------------------------------------------------------
    QP::QActive * const AO_LeftPtr = &__self_ao; // "opaque" AO pointer

    //${AOs::LeftAO} .............................................................
//${AOs::LeftAO::LeftAO} .....................................................
LeftAO::LeftAO()
  : QActive(Q_STATE_CAST(&LeftAO::initial)),
    m_timeEvt(this, TIMEOUT_SIG, 0U)
{
    // body
}

//${AOs::LeftAO::SM} .........................................................
QP::QState LeftAO::initial(LeftAO * const me, QP::QEvt const * const e) {
    // ${AOs::LeftAO::SM::initial}
    me->subscribe(BTNS_LEFT_SIG);
    // state history attributes
    me->his_history = Q_STATE_CAST(&red_on);
    return Q_TRAN(&Left);
}
//${AOs::LeftAO::SM::Left} ...................................................
QP::QState LeftAO::Left(LeftAO * const me, QP::QEvt const * const e) {
    QP::QState status_;
    switch (e->sig) {
        // ${AOs::LeftAO::SM::Left}
        case Q_ENTRY_SIG: {
            BSP::L::clr();
            status_ = Q_HANDLED();
            break;
        }
        // ${AOs::LeftAO::SM::Left::BTNS_LEFT}
        case BTNS_LEFT_SIG: {
            const auto button = Q_EVT_CAST(BtnEvt)->value;
            Q_ASSERT(button & 0xF);
            // ${AOs::LeftAO::SM::Left::BTNS_LEFT::[Stop]}
            if (button == 0b1) {
                status_ = Q_TRAN(&Left);
            }
            // ${AOs::LeftAO::SM::Left::BTNS_LEFT::[else]}
            else {
                // ${AOs::LeftAO::SM::Left::BTNS_LEFT::[else]::[red]}
                if (button == 0b10) {
                    status_ = Q_TRAN(&red_on);
                }
                // ${AOs::LeftAO::SM::Left::BTNS_LEFT::[else]::[green]}
                else if (button == 0b100) {
                    status_ = Q_TRAN(&green_on);
                }
                // ${AOs::LeftAO::SM::Left::BTNS_LEFT::[else]::[blue]}
                else if (button == 0b1000) {
                    status_ = Q_TRAN(&blue_on);
                }
                else {
                    status_ = Q_UNHANDLED();
                }
            }
            break;
        }
        default: {
            status_ = Q_SUPER(&top);
            break;
        }
    }
    return status_;
}
//${AOs::LeftAO::SM::Left::Blinky} ...........................................
QP::QState LeftAO::Blinky(LeftAO * const me, QP::QEvt const * const e) {
    QP::QState status_;
    switch (e->sig) {
        // ${AOs::LeftAO::SM::Left::Blinky}
        case Q_ENTRY_SIG: {
            BSP::L::clr();
            me->m_timeEvt.armX(BSP::TICKS_PER_SEC, BSP::TICKS_PER_SEC);
            status_ = Q_HANDLED();
            break;
        }
        // ${AOs::LeftAO::SM::Left::Blinky}
        case Q_EXIT_SIG: {
            (void)me->m_timeEvt.disarm();
            status_ = Q_HANDLED();
            break;
        }
        default: {
            status_ = Q_SUPER(&Left);
            break;
        }
    }
    return status_;
}
//${AOs::LeftAO::SM::Left::Blinky::history} ..................................
QP::QState LeftAO::history(LeftAO * const me, QP::QEvt const * const e) {
    QP::QState status_;
    switch (e->sig) {
        // ${AOs::LeftAO::SM::Left::Blinky::history}
        case Q_EXIT_SIG: {
            // save deep history
            me->his_history = me->state();
            status_ = Q_HANDLED();
            break;
        }
        default: {
            status_ = Q_SUPER(&Blinky);
            break;
        }
    }
    return status_;
}
//${AOs::LeftAO::SM::Left::Blinky::history::red_on} ..........................
QP::QState LeftAO::red_on(LeftAO * const me, QP::QEvt const * const e) {
    QP::QState status_;
    switch (e->sig) {
        // ${AOs::LeftAO::SM::Left::Blinky::history::red_on}
        case Q_ENTRY_SIG: {
            BSP::L::set_red();
            status_ = Q_HANDLED();
            break;
        }
        // ${AOs::LeftAO::SM::Left::Blinky::history::red_on::TIMEOUT}
        case TIMEOUT_SIG: {
            status_ = Q_TRAN(&off);
            break;
        }
        default: {
            status_ = Q_SUPER(&history);
            break;
        }
    }
    return status_;
}
//${AOs::LeftAO::SM::Left::Blinky::history::green_on} ........................
QP::QState LeftAO::green_on(LeftAO * const me, QP::QEvt const * const e) {
    QP::QState status_;
    switch (e->sig) {
        // ${AOs::LeftAO::SM::Left::Blinky::history::green_on}
        case Q_ENTRY_SIG: {
            BSP::L::set_green();
            status_ = Q_HANDLED();
            break;
        }
        // ${AOs::LeftAO::SM::Left::Blinky::history::green_on::TIMEOUT}
        case TIMEOUT_SIG: {
            status_ = Q_TRAN(&off);
            break;
        }
        default: {
            status_ = Q_SUPER(&history);
            break;
        }
    }
    return status_;
}
//${AOs::LeftAO::SM::Left::Blinky::history::blue_on} .........................
QP::QState LeftAO::blue_on(LeftAO * const me, QP::QEvt const * const e) {
    QP::QState status_;
    switch (e->sig) {
        // ${AOs::LeftAO::SM::Left::Blinky::history::blue_on}
        case Q_ENTRY_SIG: {
            BSP::L::set_blue();
            status_ = Q_HANDLED();
            break;
        }
        // ${AOs::LeftAO::SM::Left::Blinky::history::blue_on::TIMEOUT}
        case TIMEOUT_SIG: {
            status_ = Q_TRAN(&off);
            break;
        }
        default: {
            status_ = Q_SUPER(&history);
            break;
        }
    }
    return status_;
}
//${AOs::LeftAO::SM::Left::Blinky::off} ......................................
QP::QState LeftAO::off(LeftAO * const me, QP::QEvt const * const e) {
    QP::QState status_;
    switch (e->sig) {
        // ${AOs::LeftAO::SM::Left::Blinky::off}
        case Q_ENTRY_SIG: {
            BSP::L::clr();
            status_ = Q_HANDLED();
            break;
        }
        // ${AOs::LeftAO::SM::Left::Blinky::off::TIMEOUT}
        case TIMEOUT_SIG: {
            status_ = Q_TRAN_HIST(me->his_history);
            break;
        }
        default: {
            status_ = Q_SUPER(&Blinky);
            break;
        }
    }
    return status_;
}


}

// define other elements...
